/*                      LEKCJA09.C
//---------------------------------------------------------------------------
Temat:
        Element wielokrotny - wywoanie funkcji wirtualnej
//---------------------------------------------------------------------------
Funkcje:
        EXT(209) short GetPnt(         
        EXT(201) short GetPntInv(      
        EXT(205) void StoreMultiple(  
//---------------------------------------------------------------------------

EXT(209) short GetPnt(         // 
             double *pkt,      // wartoci wsprzdnych (x,y)
             short  setinc);   // ukad odniesienia 
             
Opis:
    Funkcja wczytuje wartoci wskazanego punktu zgodnie z ustawion opcj 
    wychwytu.
    Dla wartoci absolutnych setinc=0 dla acuchowych setinc=1

Return:
    TRUE  => po naciniciu lewego klawisza myszy
    FALSE => po naciniciu prawego klawisza myszy 

Przykad wywoania:
    a=GetPnt(&pkt,1);
//---------------------------------------------------------------------------

EXT(201) short GetPntInv(      // 
             double    *pkt,   // wartoci absolutne lub acuchowe
             short     setinc, // Inkrementalpunkt mifhren ?
             tCallBack func,   // wywoywana funkcja 
             void      *para); // wskanik wywoywanej funkcji

Opis:
    Funkcja wczytuje wartoci wskazanego punktu zgodnie z ustawion opcj 
    wychwytu.
    Kade poruszenie myszy powoduje wywoanie funkcji 'tCallBack' w ktrej
    mog by dokonywane obliczenia i wizualizacja. Jej warto 'return'
    nie jest brana pod uwag.
    Dla wartoci absolutnych setinc=0 dla acuchowych setinc=1

Return:
    TRUE  => po naciniciu lewego klawisza myszy
    FALSE => po naciniciu prawego klawisza myszy 

Przykad wywoania:
    if ( GetPntInv(&c1.xm,0,MrkCir,&c1))
//---------------------------------------------------------------------------

EXT(205) void StoreMultiple(  // 
        double      *data,    // dane elementu
        ushort      type);    // typ z parametrem DO_SAVCNT

Opis:
    Funkcja tworzy element wielokrotny (o ile sterujca ikona zostaa
    uaktywniona). 
    W przypadku linii, okrgu, uku, elipsy oraz wycinka elipsy, mona 
    uaktywni klawisz 'element wielokrotny', wtedy bdzie rysowanych kilka 
    "rwnolegych" elementw. 
    Typ naley podan wraz z DO_SAVCNT - automatycznie uruchomiona bdzie po
    stworzeniu elementu funkcja dopisania go do listy 'savecount'.

Przykad wywoania:
    StoreMultiple(&c1.xm,E_CIRCLE | DO_SAVCNT);

*/
//---------------------------------------------------------------------------
#include "std.h"
#include "megatyp.h"
#include "megacad.h"
//---------------------------------------------------------------------------
short MrkCir(
        void *argptr )
{
    t_circle *p;

    p = argptr;
    // der Kreis wird in wei gezeichnet
    DrawInv(E_CIRCLE,p,LMODE(0,PIX_XOR,BRIGHT_WHITE,0),E_CIRCLE);
    return(0);
}
//---------------------------------------------------------------------------
short main(char *filename, char *args)
{
   t_circle c1;
   t_dlgdta dlg;
   char tekst[50];

   c1.rd = 5.0;

   strcpy(dlg.text,"promie=");
   dlg.type = DLG_LEN;
   dlg.val = &c1.rd;

   while ( DlgInput(1,"Kreis",&dlg) )
   {
      for ( ; ; )
      {
         SetFuncText("okrgi wsprodkowe");
         MouseHelp("postaw","powrt",HLP_INV(RED,WHITE,0));
                                // okrg jest 'przyklejony do kursora
         if ( GetPntInv(&c1.xm,0,MrkCir,&c1) )
         {
                                // zapamitanie okrgu
            StoreMultiple(&c1.xm,E_CIRCLE | DO_SAVCNT);
         }
         else
         {
            sprintf(tekst,"x=%f  y=%f", c1.xm, c1.ym);
            Message("wsprzdne ostatniego okrgu:",
                   tekst,NULL,NULL,"ok",3);
            break;
         }
      }
   }
   return(0);
}
//---------------------------------------------------------------------------
